package com.example.addressbook.server;

import com.example.addressbook.client.AddressbookService;
import com.example.addressbook.client.Contact;
import com.google.gwt.user.server.rpc.RemoteServiceServlet;

public class AddressbookServiceImpl extends RemoteServiceServlet implements
		AddressbookService {

	@Override
	public Contact addContact(String[] data) throws IllegalArgumentException {
		
		Contact contact = new Contact();
		
		contact.setFirstName(escapeHtml(data[0]));
		contact.setLastName(escapeHtml(data[1]));
		contact.setEmail(escapeHtml(data[2]));
		contact.setMobile(escapeHtml(data[3]));
		
		return contact;
	
	}
		
	/**
	 * Escape an html string. Escaping data received from the client helps to
	 * prevent cross-site script vulnerabilities.
	 * 
	 * @param html the html string to escape
	 * @return the escaped string
	 */
	private String escapeHtml(String html) {
		if (html == null) {
			return null;
		}
		return html.replaceAll("&", "&amp;").replaceAll("<", "&lt;")
				.replaceAll(">", "&gt;");
	}

}
